/// The [globals](https://nodejs.org/api/globals.html) module.
@JS()
library nodejs_interop.node.globals;

import 'dart:js';
import 'package:js/js.dart';
import 'package:nodejs_interop/js.dart';
import 'package:nodejs_interop/src/node/buffer.dart';
import 'package:nodejs_interop/src/node/console.dart';
import 'package:nodejs_interop/src/node/events.dart';
import 'package:nodejs_interop/src/node/stream.dart';

part 'globals/module.dart';
part 'globals/options.dart';
part 'globals/process.dart';
part 'globals/require.dart';
part 'globals/system_error.dart';

/// The console object. Used to print to `stdout` and `stderr`.
@JS('console')
external Console get console;

/// The directory path of the current module.
@JS('__dirname')
external String get dirname;

/// A reference to the `module.exports` property that is shorter to type.
@JS('exports')
external dynamic get exports;

/// The file path of the current module. This is the resolved absolute path of the current module file.
@JS('__filename')
external String get filename;

/// The global namespace object.
@JS('global')
external dynamic get global;

/// A reference to the current module.
@JS('module')
external Module get module;

/// The process object.
@JS('process')
external NodeProcess get process;

/// Requires modules.
@JS('require')
external RequireFunction get require;
