part of nodejs_interop.node.globals;

/// Options used to interpret the character encoding of strings.
@JS()
@anonymous
class EncodingOptions {

  /// Creates a new options object.
  external factory EncodingOptions({String encoding = BufferEncoding.utf8});

  /// The character encoding.
  external String get encoding;
}

/// Provides options for emitting a process warning.
@JS()
@anonymous
class WarningOptions {

  /// Creates a new options object.
  external factory WarningOptions({String code, JsFunction ctor, String detail, String type = 'Warning'});

  /// A unique identifier for the warning instance being emitted.
  external String get code;

  /// An optional function used to limit the generated stack trace. Defaults to [NodeProcess.emitWarning].
  external JsFunction get ctor;

  /// Additional text to include with the error.
  external String get detail;

  /// The name to use for the type of warning being emitted.
  external String get type;
}
