part of nodejs_interop.node.stream;

/// A trivial implementation of a [Transform] stream that simply passes the input bytes across to the output.
@JS(r'$stream.PassThrough')
abstract class PassThrough<T> extends Transform<T> {

  /// Creates a new passthrough stream.
  external PassThrough([TransformOptions options]);
}

/// A [Duplex] stream where the output is in some way related to the input.
@JS(r'$stream.Transform')
abstract class Transform<T> extends Duplex<T> {

  /// Creates a new transform stream.
  external Transform([TransformOptions options]);
}

/// Options passed to transform streams.
@JS()
@anonymous
class TransformOptions extends DuplexOptions {

  /// Creates a new path object.
  external factory TransformOptions({
    Function flush,
    Function transform,
    bool allowHalfOpen = true,
    bool decodeStrings = true,
    Function destroy,
    String encoding,
    int highWaterMark,
    bool objectMode = false,
    Function read,
    int readableHighWaterMark,
    bool readableObjectMode = false,
    int writableHighWaterMark,
    bool writableObjectMode = false,
    Function write,
    Function writev
  });

  /// Implementation for the `_flush()` method.
  external Function get flush;

  /// Implementation for the `_transform()` method.
  external Function get transform;
}
