import 'dart:js';
import 'package:nodejs_interop/nodejs_interop.dart';
import 'package:test/test.dart';

/// Tests the features of the [Promise] class.
void main() => group('Promise', () {
  group('.all()', () {
    test('should return a promise that completes with the collected values from the given promises', () {
      var promises = [Promise.resolve(1), Promise.resolve(2), Promise.resolve(3)];
      Promise.all(promises).then(
        allowInterop((values) => expect(values, allOf(isList, orderedEquals([1, 2, 3])))),
        allowInterop((error) => fail('The promise was rejected: $error'))
      );
    });
  });

  group('.reject()', () {
    test('should return a promise that rejects', () => Promise.reject(new Exception('foo')).then(
      allowInterop((value) => fail('The promise was resolved: $value')),
      allowInterop((error) => expect(error, isException))
    ));
  });

  group('.resolve()', () {
    test('should return a promise that resolves', () => Promise.resolve('foo').then(
      allowInterop((value) => expect(value, equals('foo'))),
      allowInterop((error) => fail('The promise was rejected: $error'))
    ));
  });
});
