import 'package:nodejs_interop/nodejs_interop.dart';
import 'package:nodejs_interop/npm.dart';
import 'package:test/test.dart';

/// Tests the features of the [OSLocaleModule] class.
void main() => group('OSLocaleModule', () {
  final localeRegex = new RegExp(r'^[a-z]{2,3}_[A-Z]{2,3}$');
  final osLocale = loadLibrary<OSLocaleModule>('os-locale');

  group('.call()', () {
    test('should return a locale formatted like "<language>_<REGION>"', () async {
      expect(await convertToFuture(osLocale()), matches(localeRegex));
      expect(await convertToFuture(osLocale.call()), matches(localeRegex));
    });
  });

  group('.sync()', () {
    test('should synchronously return a locale formatted like "<language>_<REGION>"', () {
      expect(osLocale.sync(), matches(localeRegex));
    });
  });
});
